
package jp.gr.java_conf.u6k.andro_memo.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.IdentityType;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;

@PersistenceCapable(identityType = IdentityType.APPLICATION)
public class UserEntity {

    @PrimaryKey
    @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
    private Key key;

    @Persistent
    private String email;

    @Persistent
    private String passwordHash;

    @Persistent
    private String passwordHashAlgorithm = "SHA-512";

    @Persistent
    private Date updateDatetime;

    @Persistent
    private UserStateEnum state = UserStateEnum.LIVES;

    @Persistent(mappedBy = "user")
    private List<MemoEntity> memoList = new ArrayList<MemoEntity>();

    @Persistent(mappedBy = "user")
    private List<LoginTicketEntity> loginTicketList = new ArrayList<LoginTicketEntity>();

    public Key getKey() {
        return this.key;
    }

    public void setKey(Key key) {
        this.key = key;
    }

    public String getEmail() {
        return this.email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPasswordHash() {
        return this.passwordHash;
    }

    public void setPasswordHash(String passwordHash) {
        this.passwordHash = passwordHash;
    }

    public String getPasswordHashAlgorithm() {
        return this.passwordHashAlgorithm;
    }

    public void setPasswordHashAlgorithm(String passwordHashAlgorithm) {
        this.passwordHashAlgorithm = passwordHashAlgorithm;
    }

    public Date getUpdateDatetime() {
        return this.updateDatetime;
    }

    public void setUpdateDatetime(Date updateDatetime) {
        this.updateDatetime = updateDatetime;
    }

    public UserStateEnum getState() {
        return this.state;
    }

    public void setState(UserStateEnum state) {
        this.state = state;
    }

    public List<MemoEntity> getMemoList() {
        return this.memoList;
    }

    public void setMemoList(List<MemoEntity> memoList) {
        this.memoList = memoList;
    }

    public List<LoginTicketEntity> getLoginTicketList() {
        return this.loginTicketList;
    }

    public void setLoginTicketList(List<LoginTicketEntity> loginTicketList) {
        this.loginTicketList = loginTicketList;
    }

}
