
package jp.gr.java_conf.u6k.andro_memo.web.json_service;

import javax.jdo.PersistenceManager;
import javax.jdo.Transaction;

import jp.gr.java_conf.u6k.andro_memo.entity.PMF;
import jp.gr.java_conf.u6k.andro_memo.model.UserModel;

public class UserService {

    public String login(String email, String password) {
        PersistenceManager pm = PMF.get().getPersistenceManager();
        try {
            Transaction tx = pm.currentTransaction();
            try {
                tx.begin();

                UserModel userModel = new UserModel(pm);
                String loginTicketKey = userModel.login(email, password);

                tx.commit();

                return loginTicketKey;
            } finally {
                if (tx.isActive()) {
                    tx.rollback();
                }
            }
        } finally {
            pm.close();
        }
    }

    public void logout(String loginTicketKey) {
        PersistenceManager pm = PMF.get().getPersistenceManager();
        try {
            Transaction tx = pm.currentTransaction();
            try {
                tx.begin();

                UserModel userModel = new UserModel(pm);
                userModel.logout(loginTicketKey);

                tx.commit();
            } finally {
                if (tx.isActive()) {
                    tx.rollback();
                }
            }
        } finally {
            pm.close();
        }
    }

    public void unregist(String loginTicketKey) {
        PersistenceManager pm = PMF.get().getPersistenceManager();
        try {
            Transaction tx = pm.currentTransaction();
            try {
                tx.begin();

                UserModel userModel = new UserModel(pm);
                userModel.unregist(loginTicketKey);

                tx.commit();
            } finally {
                if (tx.isActive()) {
                    tx.rollback();
                }
            }
        } finally {
            pm.close();
        }
    }

}
