
package jp.gr.java_conf.u6k.andro_memo.web.servlet.html;

import java.io.IOException;

import javax.jdo.PersistenceManager;
import javax.jdo.Transaction;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.gr.java_conf.u6k.andro_memo.entity.PMF;
import jp.gr.java_conf.u6k.andro_memo.model.UserModel;

@SuppressWarnings("serial")
public class RegistTempServlet extends HttpServlet {

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        PersistenceManager pm = PMF.get().getPersistenceManager();
        try {
            // 入力値を取得します。
            String message = null;

            String email = req.getParameter("email");

            if (email == null) {
                message = "メールアドレスを入力してください。";
            } else {
                email = email.trim();

                if ("".equals(email)) {
                    message = "メールアドレスを入力してください。";
                } else if (!email.matches("^.+@.+$")) {
                    message = "メールアドレスを入力してください。";
                }
            }

            // 　　入力チェックがエラーの場合、メッセージを設定してregist1.jspへ遷移します。
            if (message != null) {
                req.setAttribute("message", message);
                req.setAttribute("email", email);

                this.getServletContext().getRequestDispatcher("/html/regist1.jsp").forward(req, resp);

                return;
            }

            Transaction tx = pm.currentTransaction();
            try {
                tx.begin();

                // モデル:会員仮登録を実行します。
                UserModel m = new UserModel(pm);
                m.registTemp(email);

                tx.commit();
            } finally {
                if (tx.isActive()) {
                    tx.rollback();
                }
            }

            // regist2.jspへ遷移します。
            this.getServletContext().getRequestDispatcher("/html/regist2.jsp").forward(req, resp);
        } finally {
            pm.close();
        }
    }

}
