
package jp.gr.java_conf.u6k.andro_memo.web.servlet.html.user;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.jdo.PersistenceManager;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import jp.gr.java_conf.u6k.andro_memo.entity.MemoEntity;
import jp.gr.java_conf.u6k.andro_memo.entity.PMF;
import jp.gr.java_conf.u6k.andro_memo.entity.UserEntity;
import jp.gr.java_conf.u6k.andro_memo.model.MemoModel;
import jp.gr.java_conf.u6k.andro_memo.model.UserModel;

import com.google.appengine.api.datastore.KeyFactory;

@SuppressWarnings("serial")
public class MyPageServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        PersistenceManager pm = PMF.get().getPersistenceManager();
        try {
            HttpSession session = req.getSession();
            String loginTicketKey = (String) session.getAttribute("login.loginTicketKey");

            UserModel userModel = new UserModel(pm);
            UserEntity user = userModel.findLoginUser(loginTicketKey);

            MemoModel memoModel = new MemoModel(pm);
            List<MemoEntity> l = memoModel.findAll(loginTicketKey);

            List<Map<String, Object>> memoList = new ArrayList<Map<String, Object>>();
            for (MemoEntity memo : l) {
                Map<String, Object> m = new HashMap<String, Object>();

                m.put("key", KeyFactory.keyToString(memo.getKey()));
                m.put("title", memo.getTitle());
                m.put("updateDatetime", memo.getUpdateDatetime());

                memoList.add(m);
            }

            req.setAttribute("email", user.getEmail());
            req.setAttribute("memoList", memoList);

            req.getRequestDispatcher("/html/user/mypage.jsp").forward(req, resp);
        } finally {
            pm.close();
        }
    }

}
